; BashHere installation script
; Dmitry V. Fedorov <www.dimin.net>
; ver: 1

;--------------------------------
;Include Modern UI

  !include "MUI.nsh"
;--------------------------------  

; The name of the installer
Name "DIMIN PromptHere"

; The file to write
OutFile ".\promptHere.exe"

; The default installation directory
InstallDir $PROGRAMFILES\DIMIN\promptHere
; Registry key to check for directory (so if you install again, it will 
; overwrite the old one automatically)
InstallDirRegKey HKLM SOFTWARE\DIMIN "promptHere_Install_Dir"

ShowInstDetails show
CRCCheck on

; The text to prompt the user to enter a directory
ComponentText "This will install DIMIN CommandPromptHere on your computer. Select which optional things you want installed."
; The text to prompt the user to enter a directory
DirText "Choose a directory to install in to:"

;--------------------------------
;Interface Settings

  !define MUI_ABORTWARNING
  ;!define MUI_COMPONENTSPAGE_NODESC
  !define MUI_COMPONENTSPAGE_SMALLDESC
 
  !define MUI_FINISHPAGE_NOAUTOCLOSE
  
;--------------------------------
;Pages

  ;!insertmacro MUI_PAGE_LICENSE "LICENSE.txt"
  ;!insertmacro MUI_PAGE_COMPONENTS
  !insertmacro MUI_PAGE_DIRECTORY
  !insertmacro MUI_PAGE_INSTFILES
  !insertmacro MUI_PAGE_FINISH
  
  !insertmacro MUI_UNPAGE_CONFIRM
  !insertmacro MUI_UNPAGE_INSTFILES
  
;--------------------------------
;Languages
 
  !insertmacro MUI_LANGUAGE "English"

;--------------------------------------------------------------
; The stuff to install
Section "-PromptHere (required)"
  
  WriteRegStr HKCR "Directory\shell\Dimin.promptHere" "" "Command Prompt Here"
  WriteRegStr HKCR "Directory\shell\Dimin.promptHere\command" "" 'cmd.exe "%1"'
  WriteRegStr HKCR "*\shell\Dimin.promptHere" "" "Command Prompt Here"
  WriteRegStr HKCR "*\shell\Dimin.promptHere\command" "" 'cmd.exe "%1"'  
        
  ; Write the installation path into the registry
  WriteRegStr HKLM SOFTWARE\DIMIN "promptHere_Install_Dir" "$INSTDIR"
  ; Write the uninstall keys for Windows
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\diminPromptHere" "DisplayName" "DIMIN CommandPromptHere (remove only)"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\diminPromptHere" "UninstallString" '"$INSTDIR\promptHere_uninstall.exe"'
 
  WriteUninstaller "promptHere_uninstall.exe"
 
SectionEnd


; uninstall stuff

UninstallText "This will uninstall DIMIN CommandPromptHere. Hit next to continue."

; special uninstall section.
Section "Uninstall"
  ; remove registry keys
  DeleteRegKey HKCR "Directory\shell\Dimin.promptHere"
  DeleteRegKey HKCR "*\shell\Dimin.promptHere"
  
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\diminPromptHere"
  DeleteRegKey HKLM "Software\DIMIN\promptHere_Install_Dir"
  DeleteRegKey HKCU "Software\DIMIN\promptHere"  

  ; MUST REMOVE UNINSTALLER, too
  Delete $INSTDIR\promptHere_uninstall.exe
  RMDir "$INSTDIR"
  
SectionEnd

; eof
